<?php

class openapi_data_original_appropriation{

    public function add($data){
        $result = array('rsp'=>'succ','msg' => '调拨单创建成功');
        $oAppropriation = app::get('taoguanallocate')->model('appropriation');
        $oAppropriation_items = app::get('taoguanallocate')->model('appropriation_items');
        $appropriationObj = kernel::single('taoguanallocate_appropriation');
        $channelLib = kernel::single('channel_func');
        $oStock = kernel::single('console_stock_products');
        $appropriation_type = $data['appropriation_type'];
        $from_branch = $data['from_branch'];
        $to_branch = $data['to_branch'];
        $logi_name = $data['logi_name'];
        $operator = $data['operator']?$data['operator']:'未知';
        $is_check = $data['is_check'];
        $memo = $data['memo'];     
        $items = json_decode($data['items'],true);
        if ($appropriation_type == '' || $from_branch == '' || $to_branch == '' || $items == '') {
            $result['rsp'] = 'fail';
            $result['msg'] = '必填字段不可为空!';
            return $result;
        }
        //判断调出仓库是否存在
        if(!$from_branch_ids = $this->_getBranchByname($from_branch)){
            $result['rsp'] = 'fail';
            $result['msg'] = '调出仓库不存在!';
            return $result;
        }
        $from_branch_id = $from_branch_ids['branch_id'];
        //判断调入仓库是否存在
        if(!$to_branch_ids = $this->_getBranchByname($to_branch)){
            $result['rsp'] = 'fail';
            $result['msg'] = '调入仓库不存在!';
            return $result;
        }
        $to_branch_id = $to_branch_ids['branch_id'];
        //判断调拨类型
        if($appropriation_type =='直接调拨'){
            $type = 1;
            //判断仓库类型
            if(!$channelLib->isSelfWms($from_branch_ids['wms_id'])||!$channelLib->isSelfWms($to_branch_ids['wms_id'])){
                $result['rsp'] = 'fail';
                $result['msg'] = '调拨类型为直接调拨时，仓库类型必须为自有仓库!';
                return $result;
            }
            
        }elseif ($appropriation_type == '出入库调拨') {
            $type = 2;
        }  else {
            $result['rsp'] = 'fail';
            $result['msg'] = '调拨类型不存在!';
            return $result;
        }
        if(!is_array($items)){
            $result['rsp'] = 'fail';
            $result['msg'] = 'items参数必须为数组!';
            return $result; 
        }
        //判断物流公司
        if(!empty($logi_name)){
            if(!$corp_ids=  $this->_getCorpByName($logi_name)){
                $result['rsp'] = 'fail';
                $result['msg'] = '物流公司不存在!';
                return $result; 
            }
        }
        $corp_id = $corp_ids['corp_id'];
        foreach ($items as $item) {
            if(!$item['bn'] || !$item['nums']){
                $result['rsp'] = 'fail';
                $result['msg'] = 'items必填字段不可为空!';
                return $result;
            }
            if(!$bproduct = $this->_getProductByBnId($item['bn'],$from_branch_id)){                
                $result['rsp'] = 'fail';
                $result['msg'] = '在'.$from_branch.'仓库不存在'.'货号'.$item['bn'].'!';
                return $result;
            }
            if (!is_numeric($item['nums']) || $item['nums'] < 1){
                $result['rsp'] = 'fail';
                $result['msg'] = '货号'.$item['bn'].'的退货数量必须为数字且大于0!';
                return $result;
            }         
            if($item['nums'] > $bproduct['store']){
                $result['rsp'] = 'fail';
                $result['msg'] = '货号'.$item['bn'].'的调拨数量不可大于库存数量!';
                return $result;
            }            
            unset($item);
        }
        $appropriation_no = $appropriationObj->gen_appropriation_no();
        $appro_data = array(
            'appropriation_no'=> $appropriation_no,
            'type' => 0,
            'create_time' => time(),
            'operator_name' => $operator,
            'memo' => $memo,
            'corp_id' => $corp_id,
        );
        $oAppropriation->save($appro_data);             
        $appropriation_id = $appro_data['appropriation_id'];
        foreach ($items as $item) {
            $product = $this->_getProductByBn($item['bn']);
            $from_branch_num = $oStock->get_branch_usable_store($from_branch_id,$product['product_id']);
            $to_branch_num = $oStock->get_branch_usable_store($to_branch_id,$product['product_id']);
            $item_data = array(
                'appropriation_id'=>$appropriation_id,
                'bn'=>$item['bn'],
                'product_name'=>$product['name'],
                'product_id'=>$product['product_id'],
                'from_branch_id'=>$from_branch_id==''? 0:$from_branch_id,
                'from_pos_id'=>$from_pos_id=='' ? 0:$from_pos_id,
                'to_branch_id'=>$to_branch_id=='' ? 0:$to_branch_id,
                'to_pos_id'=>$to_pos_id=='' ? 0:$to_pos_id,
                'num'=>$item['nums'],
                'from_branch_num'=>$from_branch_num,
                'to_branch_num'=>$to_branch_num,
            );
            $oAppropriation_items->save($item_data);
        }
        if($type == 1){//直接调拨
            if($this->do_iostock($appropriation_id,$msg)){
                return $result;
            }  else {
                $result['rsp'] = 'fail';
                $result['msg'] = $msg;
                return $result;
            }
        }else{//出入库调拨，先生成出库单，出库单确认后生成入库单,出入库单确认后，生成出入库明细
            $iso_id = $this->do_out_iostockorder($appropriation_id,$msg);
            if($iso_id){
                if($is_check=='是'){
                    $this->doCheck($iso_id, $msg);
                    $result['rsp'] = 'succ';
                    $result['msg'] = $msg;
                    return $result;
                }
                return $result;
            }  else {
                $result['rsp'] = 'fail';
                $result['msg'] = $msg;
                return $result;
            }
        } 
    }
    //通过仓库名称获取仓库的id
    private function _getBranchByname($branch_name) {
        $branchModel = app::get('ome')->model('branch');
        $branch = $branchModel->dump(array( 'name' => $branch_name),'branch_id,wms_id');
        return $branch;
    }
    //通过货号和仓库id判断这个仓库里面是否存在这个货品和获取货品的id
    private function _getProductByBnId($bn,$branch_id) {
        $productModel = app::get('ome')->model('products');
        $branchModel = app::get('ome')->model('branch_product');
        $product = $productModel->dump(array( 'bn' => $bn),'product_id');
        $bproduct = $branchModel->dump(array('branch_id'=> $branch_id,'product_id'=>$product['product_id']));
        return $bproduct;
    }
    //通过货号获取货品的信息
    private function _getProductByBn($bn) {
        $productModel = app::get('ome')->model('products');
        $product = $productModel->dump(array( 'bn' => $bn),'product_id,bn,name');
        return $product;
    }
    //通过货号获取货品的信息
    private function _getCorpByName($name) {
        $corpModel = app::get('ome')->model('dly_corp');
        $corp = $corpModel->dump(array( 'name' => $name),'corp_id');
        return $corp;
    }
    
    /**
   * 
   * 调拔单出库
   * @param  appropriation_id
   * @param  $msg
   */
   function do_out_iostockorder($appropriation_id,&$msg){
       #判断是否开启固定成本，如果开启，price等于商品成本价
       $cost = false;
       if(app::get('tgstockcost')->is_installed()){
           $tgstockcost = app::get("ome")->getConf("tgstockcost.cost");
           if($tgstockcost == 2){
               $cost= true;
           }
       }
        $iostock_instance = kernel::service('ome.iostock');   
        $appitemObj = app::get('taoguanallocate')->model('appropriation_items');
        $objProducts = app::get('ome')->model('products');
        $products = array();
        $db = kernel::database();
        $sql = 'SELECT * FROM `sdb_taoguanallocate_appropriation` WHERE `appropriation_id`=\''.$appropriation_id.'\'';
        $app_detail = $db->selectrow($sql);
        $app_items_detail = $appitemObj->getList('*', array('appropriation_id'=>$appropriation_id), 0, -1);
        $branch_id = 0;
        $to_branch_id = 0;
        if ($app_items_detail){
            foreach ($app_items_detail as $k=>$v){
            	if(!$branch_id){
                    $branch_id = $v['from_branch_id'];
            	}

                if(!$to_branch_id){
                    $to_branch_id = $v['to_branch_id'];
                }

            	if($cost){
            	    #如果已经开启固定成本，则获取商品的成本价
            	    $product=$db->selectRow('select cost,unit from sdb_ome_products where product_id='.$v['product_id']);
            	}else{
            	    #如果没有开启，则不需要获取成本价
            	    $product = $objProducts->dump(array('product_id'=>$v['product_id']),'unit');

            	    #调拨出库时，获取对应的单位成本
            	    $unit_cost = $db->selectRow('select unit_cost from  sdb_ome_branch_product where branch_id='.$branch_id.' and product_id='.$v['product_id']);
            	    $product['cost'] = $unit_cost['unit_cost'];
            	}
              
                $products[$v['product_id']] = array(
                    'unit'=>$product['unit'],
                    'name'=>$v['product_name'],
                    'bn'=>$v['bn'],
                    'nums'=>$v['num'],
                    'price'=>$product['cost']?$product['cost']:0
                );
            }
        }
        
        eval('$type='.get_class($iostock_instance).'::ALLOC_LIBRARY;');
        $data =array (
           'iostockorder_name' => date('Ymd').'出库单', 
           'supplier' => '', 
           'supplier_id' => 0, 
           'branch' => $branch_id,
           'extrabranch_id'=>$to_branch_id,
           'type_id' => $type, 
           'iso_price' => 0,
           'memo' => $app_detail['memo'], 
           'operator' => 'admin', 
           'original_bn'=>'',
           'original_id'=>$appropriation_id,
           'products'=>$products,
           'appropriation_no'=>$app_detail['appropriation_no']
       );
        if ($app_detail['corp_id']) {
            $data['corp_id'] = $app_detail['corp_id'];
        }

        $iostockorder_instance = kernel::single('console_iostockorder');
        return $iostockorder_instance->save_iostockorder($data,$msg);
    }

    /**
    * 
    * 生成调拨单出入库明细
    * @param  $appropriation_id 
    * @param 
    * @param  $msg
    */
    function do_iostock($appropriation_id,&$msg){
    	$allow_commit = false;
        kernel::database()->exec('begin');
        $iostock_instance = kernel::service('ome.iostock');
        if ( method_exists($iostock_instance, 'set') ){
            //存储出入库记录
            $iostock_data = $this->get_iostock_data($appropriation_id);
            $out = array();//调出
            $in = array();//调入
            //$oBranchProduct   = app::get('ome')->model('branch_product');
            foreach($iostock_data as $item_id=>$iostock){
            	$iostock['nums'] = abs($iostock['nums']);
            	
            	$iostock['branch_id'] = $iostock['from_branch_id'];
            	unset($iostock['from_branch_id']);
            	$out[$item_id] = $iostock;
            	
            	$iostock['branch_id'] = $iostock['to_branch_id'];
            	unset($iostock['to_branch_id']);
            	$in[$item_id] = $iostock;
            
            }
            if(count($out) > 0){
            	eval('$type='.get_class($iostock_instance).'::ALLOC_LIBRARY;');
            	$iostock_bn = $iostock_instance->get_iostock_bn($type);
            	$io = $iostock_instance->getIoByType($type);
	            if ( $iostock_instance->set($iostock_bn, $out, $type, $out_msg, $io) ){
                        $allow_commit = true;
	            }
            }
            if(count($in) > 0 && $allow_commit){
            	$allow_commit = false;
            	eval('$type='.get_class($iostock_instance).'::ALLOC_STORAGE;');
            	$iostock_bn = $iostock_instance->get_iostock_bn($type);
            	$io = $iostock_instance->getIoByType($type);
	            if ( $iostock_instance->set($iostock_bn, $in, $type, $in_msg, $io) ){
                        $allow_commit = true;
	            }
            }
            
        }
        if ($allow_commit == true){
            kernel::database()->commit();
            return true;
        }else{
            kernel::database()->rollBack();
            $msg['out_msg'] = $out_msg;
            $msg['in_msg'] = $in_msg;
            return false;
        }
        
    }

    /**
     * 组织出库数据
     * @access public
     * @param String $iso_id 出入库ID
     * @return sdf 出库数据
     */
    public function get_iostock_data($appropriation_id){
        
        $appitemObj = app::get('taoguanallocate')->model('appropriation_items');
        
        $iostock_data = array();
        $db = kernel::database();
        $sql = 'SELECT * FROM `sdb_taoguanallocate_appropriation` WHERE `appropriation_id`=\''.$appropriation_id.'\'';
        $app_detail = $db->selectrow($sql);
        $app_items_detail = $appitemObj->getList('*', array('appropriation_id'=>$appropriation_id), 0, -1);
        if ($app_items_detail){
            foreach ($app_items_detail as $k=>$v){

                $bp_data = $db->selectrow('select unit_cost from sdb_ome_branch_product where branch_id = '.$v['from_branch_id'].' and product_id = '.$v['product_id']);
                
                $iostock_data[$v['item_id']] = array(
                    'from_branch_id' => $v['from_branch_id'],
                    'to_branch_id' => $v['to_branch_id'],
                    'original_bn' => '',
                    'original_id' => $appropriation_id,
                    'original_item_id' => $v['item_id'],
                    'supplier_id' => 0,
                    'bn' => $v['bn'],
                    'iostock_price' => $bp_data['unit_cost']?$bp_data['unit_cost']:0,
                    'nums' => $v['num'],
                    'oper' => $app_detail['operator_name'],
                    'create_time' => $app_detail['create_time'],
                    'operator' => 'admin',
                    'memo' => $app_detail['memo'],
                );
            }
        }
        return $iostock_data;
    }
    /**
     * 出库审核
     * @access public
     * @param String $iso_id 出入库ID
     * @return 
     */
    public function doCheck($iso_id,&$msg){
        #更新单据审核状态
        $iso_id = intval($iso_id);
        $io = '0';
        $pStockObj = kernel::single('console_stock_products');
        $isoObj = app::get('taoguaniostockorder')->model('iso');

        #库存状态判断\
        $iso = $isoObj->dump($iso_id,'check_status,branch_id,iso_bn');
        $branch_id = $iso['branch_id'];
        if ($iso['check_status']!='1'){
            $msg='出库单已审核!';
        }

        if ($io == '0'){
            $oIso_items = app::get('taoguaniostockorder')->model('iso_items');
            #需要判断可用库存是否足够
            $iso_items = $oIso_items->getlist('bn,nums,product_id',array('iso_id'=>$iso_id),0,-1);

            foreach($iso_items as $ik=>$iv){
                //判断选择商品库存是否充足
                $usable_store = $pStockObj->get_branch_usable_store($branch_id,$iv['product_id']);

                if($iv['nums'] > $usable_store){
                    $msg = '出库数量不可大于库存数量.'.$usable_store;
                }
            }

        }
        $iso_data = array('check_status'=>'2');
        $result = $isoObj->update($iso_data,array('iso_id'=>$iso_id));
        if ($result){
            if ($io == '0'){
                #将库存冻结
                kernel::single('console_receipt_stock')->clear_stockout_store_freeze(array('iso_bn'=>$iso['iso_bn']),'+');
                #出库
                kernel::single('console_event_trigger_otherstockout')->create(array('iso_id'=>$iso_id),false);
            }else{
                #入库
                kernel::single('console_event_trigger_otherstockin')->create(array('iso_id'=>$iso_id),false);
            }

            $msg='调拨单创建成功，出库单审核成功!';
        }else{
            $msg='调拨单创建成功，出库单审核失败!';
        }

    }

}